Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.collections.functors
Class SwitchTransformer

    java.lang.Object
      |
      +--org.apache.commons.collections.functors.SwitchTransformer

All Implemented Interfaces:
  Serializable, Transformer

public class SwitchTransformer
extends Object
implements Transformer, Serializable

Transformer implementation calls the transformer whose predicate returns true, like a switch statement.

Since:
  Commons Collections 3.0
Version:
  $Revision: 1.5 $ $Date: 2004/05/16 11:36:31 $
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Constructor Summary
`SwitchTransformer(Predicate[] predicates, Transformer[] transformers, Transformer defaultTransformer)` Constructor that performs no validation.

Method Summary
`Transformer` | `getDefaultTransformer()` Gets the default transformer.
`static Transformer` | `getInstance(Map predicatesAndTransformers)` Create a new Transformer that calls one of the transformers depending on the predicates.
`static Transformer` | `getInstance(Predicate[] predicates, Transformer[] transformers, Transformer defaultTransformer)` Factory method that performs validation and copies the parameter arrays.
`Predicate[]` | `getPredicates()` Gets the predicates, do not modify the array.
`Transformer[]` | `getTransformers()` Gets the transformers, do not modify the array.
`Object` | `transform(Object input)` Transforms the input to result by calling the transformer whose matching predicate returns true.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### SwitchTransformer

    public SwitchTransformer(Predicate[] predicates,
                             Transformer[] transformers,
                             Transformer defaultTransformer)

  Constructor that performs no validation. Use `getInstance` if you want that.

Parameters:
  `predicates` - array of predicates, not cloned, no nulls
  `transformers` - matching array of transformers, not cloned, no nulls
  `defaultTransformer` - the transformer to use if no match, null means nop

Method Detail

### getInstance

    public static Transformer getInstance(Predicate[] predicates,
                                          Transformer[] transformers,
                                          Transformer defaultTransformer)

  Factory method that performs validation and copies the parameter arrays.

  Parameters:
    `predicates` - array of predicates, cloned, no nulls
    `transformers` - matching array of transformers, cloned, no nulls
    `defaultTransformer` - the transformer to use if no match, null means nop
  Returns:
    the `chained` transformer
  Throws:
    `IllegalArgumentException` - if array is null
    `IllegalArgumentException` - if any element in the array is null

### getInstance

    public static Transformer getInstance(Map predicatesAndTransformers)

  Create a new Transformer that calls one of the transformers depending on the predicates.

  The Map consists of Predicate keys and Transformer values. A transformer is called if its matching predicate returns true. Each predicate is evaluated until one returns true. If no predicates evaluate to true, the default transformer is called. The default transformer is set in the map with a null key. The ordering is that of the iterator() method on the entryset collection of the map.

  Parameters:
    `predicatesAndTransformers` - a map of predicates to transformers
  Returns:
    the `switch` transformer
  Throws:
    `IllegalArgumentException` - if the map is null
    `IllegalArgumentException` - if any transformer in the map is null
    `ClassCastException` - if the map elements are of the wrong type

### transform

    public Object transform(Object input)

  Transforms the input to result by calling the transformer whose matching predicate returns true.

  Specified by:
    `transform` in interface `Transformer`
  Parameters:
    `input` - the input object to transform
  Returns:
    the transformed result

### getPredicates

    public Predicate[] getPredicates()

  Gets the predicates, do not modify the array.

  Returns:
    the predicates
  Since:
    Commons Collections 3.1

### getTransformers

    public Transformer[] getTransformers()

  Gets the transformers, do not modify the array.

  Returns:
    the transformers
  Since:
    Commons Collections 3.1

### getDefaultTransformer

    public Transformer getDefaultTransformer()

  Gets the default transformer.

  Returns:
    the default transformer
  Since:
    Commons Collections 3.1

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2001-2004 Apache Software Foundation. All Rights Reserved.